<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: Script/createSimulationView.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: Script/createSimulationView.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * Stimulation Client
 * @module n_create_simulation_view_client
 */

/** @function n_1_startStimulation
 * @description exported function : needed to select and visualize audio data
 * &lt;p> - the internals of this function are described in the linked namespace&lt;/p>
 * &lt;h2>Parent&lt;/h2>
 * &lt;p>This is the top level script. It is embedded in signalsNOsci.html&lt;/p>
 * &lt;h2>Child&lt;/h2>
 * &lt;p>[function body n_create_simulation_view_client]{@link  n_create_simulation_view_client.n_1_create_simulation_view}&lt;/p>
 * &lt;h2>Emitted socket.io Events and Receivers&lt;/h2>
 * &lt;table>
 * &lt;tr>
 * &lt;thead>
 * &lt;th>Initial event emit&lt;/th>&lt;th>Server : receive event&lt;/th>&lt;th>Client : get response&lt;/th>
 * &lt;/thead>
 * &lt;tbody>
 * &lt;td>getAudioFlPths&lt;/td>
 * &lt;td>[server reacts on stimulation request]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.event:getAudioFlPths}&lt;/td> 
 * &lt;td>[client receives stimulation data]{@link n_create_simulation_view_client.n_1_create_simulation_view.event:sendAudioFlPths}
 * &lt;tr>
 * &lt;/tbody>
 * &lt;/table>
*/

var d3 = window.d3;

function createInputSignalImage(grpSel,inCirc,x_,y_,idstr,i)
{
  inCirc.append('circle').attr('cx',x_).attr('cy',y_).attr('r',10).attr('stroke','black').attr('fill','green'); 
  var str = "input " + i;
  idstr = "inputno" + i;      
  var insel = grpSel.append('tr');
  insel.append('td').attr('class','selector').append('button').text('Sel.Stim');         
  insel.append('td').append('button').text(str).attr('id',idstr)
    .data([0])
    .on('click',function()
    {
        var src = d3.select('.audio').select('p').node().innerHTML;
        var inChnlNo = this.innerHTML
        d3.select('.audio').select('p').text('srcChnlNo: '+ src +'; inNo: ' + inChnlNo);                
        d3.select(this.parentNode.parentNode).select('.selector').select('button').node().innerHTML=src;
    });           
  insel.append('td').append('div').attr('class','emptyStub');     
}
                                
function createOutputSignalImage(grpSel,outCirc,outx,yo_,i)
{
  outCirc.append('circle').attr('cx',outx).attr('cy',yo_-20).attr('r',10).attr('stroke','black').attr('fill','cyan');   
  var str = "output " + i;
  var idstr = "outputno" + i;      
    var outSel = d3.select(grpSel.selectAll('tr').nodes()[i]);
    //.select().append('td').append('button').text(str).attr('id',idstr)
    var nd = outSel.node();
    if(nd===null)
    { 
      var selNew = grpSel.append('tr');         
      selNew.append('td').append('div').attr('class','replaceButton');         
      selNew.append('td').append('div').attr('class','replaceButton');         
      selNew.append('td').append('div').attr('class','emptyStub');         
      selNew.append('td').append('button').text(str).attr('id',idstr)
      .data([0])
      .on('click',function(){d3.select(this).data()[0];});           
      selNew.append('td').append('button').text('sel Osci');                
    }
    else
    {           
      outSel.append('td').append('button').text(str).attr('id',idstr)
      .data([0])
      .on('click',function(){ d3.select(this).data()[0];});         
      outSel.append('td').append('button').text('sel Osci');      
    }  
}

function  createSimulationView(socket,startFileExample,Oscilloscope){

  /**
     * Foo object (@see: {@link module:audio-element~startFileExample})
     * @name n_create_simulation_view_client
     * @inner
     * @private
     * @memberof module:n_create_simulation_view_client
     * @property {Object} n_create_simulation_view_client - The foo object
     * @property {Object} n_create_simulation_view_client.n_1_create_simulation_view - The bar object     
     * @property {Object} n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths - The bar object     
     */
 
   /**
     * Generate inner namespace of the startFileExample
     * @memberof n_create_simulation_view_client
     * @type {object}
     * @namespace n_create_simulation_view_client.n_1_create_simulation_view
     * @description &lt;h2>Parent&lt;/h2> [function call n_create_simulation_view_client]{@link module:n_create_simulation_view_client}
     * &lt;h2>Child&lt;/h2>
     * [function body n_create_simulation_view_client]{@link  n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths}
     * 
     */


    /**     
      * @memberof n_create_simulation_view_client.n_1_create_simulation_view    
      * @event periodic_time
      * @type {object}
      * @property {function} console.log(timeString)      
      * @description This event is currently triggering an almost empty 
      * function which only displays the timestamps sent by the server. 
      * &lt;br>[server: create basic time period]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.event:time}
    */ 
    socket.on('time', function(timeString) {
        console.log(timeString)
      });
      
      const noInputs = 5;
      const noOutputs = 7;
      
    /**     
      * @memberof n_create_simulation_view_client.n_1_create_simulation_view    
      * @event getAudioFlPths      
      * @property {string} getAudioFlPths name of the emitted event
      * @property {number} constant 1 : number of the requested mode
      * @description This event is requesting stimulation data from the server
      * which is stored as a set of audio files on the server host engine. 
    */ 
      socket.emit('getAudioFlPths',1);

    /**     
      * @memberof n_create_simulation_view_client.n_1_create_simulation_view    
      * @event sendAudioFlPths      
      * @property {string} sendAudioFlPths name of the emitted event
      * @property {function} function(data) processes the received data
      * @description This event is requesting stimulation data from the server
      * which is stored as a set of audio files on the server host engine. 
      * [process stimulation data]{@link n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths}
    */ 
      socket.on('sendAudioFlPths', function(data) {

   /**
     * Generate inner namespace of the startFileExample
     * @memberof n_create_simulation_view_client.n_1_create_simulation_view    
     * @type {object}
     * @namespace n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths
     * 
     */

        /**
        * Generate inner namespace of the startFileExample
        * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths
        * @function append_svg
        * @param {string} body append svg object to existing body
        * @description create a 1st area for scalabe vector graphics, 
        * 
        */
        var svg = d3.select('body').append('svg');
        /**
        * Generate inner namespace of the startFileExample
        * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths
        * @function append_table_group
        * @param {string} body append table object to existing body
        * @param {string} table append table object
        * @param {attribute} class 'signal'
        * @param {string} g group element of HTML DOM 
        * @description append a table to the existing html body, indicate the table
        * as a class names 'signals' and append a HTML group to the table. 
        */
        var grpSel = d3.select('body').append('table').attr('class','signals').append('g');
        var lock = false;

        /**
        * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths
        * @function for_data_iterator
        * @param {number} 0 iterator initial value 
        * @param {number} i iterator
        * @param {number} length stop condition of the loop is the data length 
        * @description iterator over all data elements. Once the data is not empty
        * the underlying audio file is further processed. 
        */
        for(var i=0;i&lt;data.length;i+=1)
        {    
          if(data[i]!=="")
          {     
            if(lock===false)                      
            {
                /**
                  * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths
                  * @function startFileExample
                  * @param {number} 0 iterator initial value 
                  * @param {number} i iterator
                  * @param {number} length stop condition of the loop is the data length 
                  * @description iterator over all data elements. Once the data is not empty
                  * the underlying audio file is further processed. 
                  * &lt;br>&lt;br>[start simulation]{@link module:k_select-stimulation_client}
                */
              startFileExample(data[i],d3.select,Oscilloscope);
              
              lock=true;
              
            }

            /**
              * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths
              * @type {string}
              */
            var str = "signal no " + i;
            /**
            * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths
            * @type {string}
            */
            var idstr = "signalno" + i;      

            /**     
             * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths    
             * @event click_stimFileSelector      
             * @property {number} data name of the emitted event
             * @property {function} function(data) processes the received data
             * @description This event is requesting stimulation data from the server
             * which is stored as a set of audio files on the server host engine. 
            */ 
            grpSel.append('tr').append('td').append('button').text(str).attr('id',idstr)
              .data([data[i]])
              .on('click',
                /**     
                  * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths    
                  * @function onstimFileSelector_click      
                  * @property {number} data name of the emitted event
                  * @property {function} function(data) processes the received data
                  * @description Callback function of mouse click on the wav file 
                  * source button. The callback deletes a preexisting audio 
                  * node and creates a new one from the selected data. The
                  * selection happens by clicking the push button which corresponds
                  * to a wav file. 
                  * &lt;br>[start simulation creates the audio context]{@link module:k_select-stimulation_client}
                */               
                function()
                {
                    var pth = d3.select(this).data()[0];
                    if(d3.select('.audio').node()!==null)
                    {
                        var nd = d3.select('.audio').node();          
                        nd.remove();
                    }        
                    startFileExample(pth,d3.select,Oscilloscope);   
                    var elementText =  this.innerHTML;
                    d3.select('.audio').select('p').text(elementText)
                    var audio = document.getElementsByClassName("myAudio");
                    audio[audio.length-1].loop = true;
                    audio[audio.length-1].load();
                });       
          }
        }
        /**     
          * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths    
          * @function append_in_out_table_grp
          * @property {string} body body of the html 
          * @property {string} table html table
          * @property {class} inandout name of the table class
          * @description Creates an empty table and appends an html group. The table is used as a framework
          * to place push buttons for input and output signals. 
          * &lt;br>[start simulation creates the audio context]{@link module:k_select-stimulation_client}
        */               
        grpSel = d3.select('body').append('table').attr('class','inandout');//.append('g');

        /**     
          * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths    
          * @type {number}
          * @description number of rows of the I/O is the maximum of the number of inputs and outputs
        */
        var norows = noInputs > noOutputs ? noInputs:noOutputs;
        var x_= 10;
        var y_= 20;
        //var yo_= 20;
        var svgGrp =null;
        svgGrp = svg.append('g');

        /**     
          * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths    
          * @function createIOFrame
          * @param {string} inval
          * @param {string} outval
          * @param {string} plant
          * @param {number} rectWidth
          * @param {number} rectHeight
          * @description number of rows of the I/O is the maximum of the number of inputs and outputs
        */
        var inCirc = svgGrp.append('g').attr('class','inval');
        var outCirc = svgGrp.append('g').attr('class','outval');
        var plantSel = svgGrp.append('g').attr('class','plant');
        var svgRect = svg.node().getBoundingClientRect();
        var rectWidth = svgRect.width-80;
        var rectHeight =svgRect.height-80
        var outx = x_ + rectWidth + 20;
        plantSel.append('rect').attr('x',x_+10).attr('y',0).attr('width',rectWidth).attr('height',rectHeight).attr("fill",'blue');  

        /**     
          * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths    
          * @function getBoundingClientRect
          * @param {string} plant
          * @description get the coordinates of the 
        */
        var Rect = d3.select('.plant').node().getBoundingClientRect();
        var dYI = 0.9*(Rect.height)/noInputs;
        var dYO = 0.9*(Rect.height)/noOutputs;

        dYI = dYI&lt;dYO ? dYI:dYO;

        /**     
          * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths    
          * @function forAllRows
          * @param {string} plant
          * @description get the coordinates of the 
        */
        for(i=0;i&lt;norows;i+=1)
        {   
          if(i&lt; noInputs)
          {
            /**     
            * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths    
            * @function createInputSignalImage
            * @param {object} grpSel,inCirc,x_,y_,idstr,i
            * @param {object} inCirc
            * @param {number} x_
            * @param {number} y_
            * @param {string} idstr
            * @param {number} i
            * @description get the coordinates of the 
            */
            createInputSignalImage(grpSel,inCirc,x_,y_,idstr,i);            
          }
          if(i&lt; noOutputs)
          {
            /**     
            * @memberof n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths    
            * @function createOutputSignalImage
            * @param {object} grpSel,inCirc,x_,y_,idstr,i
            * @param {object} outCirc
            * @param {number} outx
            * @param {number} y_            
            * @param {number} i
            * @description get the coordinates of the 
            */
            createOutputSignalImage(grpSel,outCirc,outx,y_,i);            
          }
          y_ += dYI;
        }
        
        var inCircRect = d3.select('.inval').node().getBoundingClientRect();
        var outCircRect = d3.select('.outval').node().getBoundingClientRect();
        var grpRect = svgGrp.node().getBoundingClientRect();
        
        
        var YshiftOut = (Rect.bottom - outCircRect.bottom)-(Rect.height - outCircRect.height)/2;
        var YshiftIn = (Rect.bottom - inCircRect.bottom)-(Rect.height - inCircRect.height)/2;
        var YshiftGrp = (svgRect.bottom - grpRect.bottom)-(svgRect.height - grpRect.height)/2;
        var XshiftGrp = (svgRect.right - grpRect.right)-(svgRect.width - grpRect.width)/2;
        
        d3.select('.inval').attr('transform','translate(0,'+YshiftIn+')');
        d3.select('.outval').attr('transform','translate(0,'+YshiftOut+')');
        svgGrp.attr('transform','translate('+XshiftGrp+','+YshiftGrp+')');
      });
      
}

export {createSimulationView}</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
